package main

import (
	"github.com/raspi/heksa/pkg/color"
)

const (
	//availFlags = "-+# 0"
	esc   = "\033["
	clear = esc + "0m"

	LineEven = esc + "48;5;16m"
	LineOdd  = esc + "48;5;235m"
)

var defaultColor = color.ColorGrey93_eeeeee
var defaultLineColor = color.ColorCyan1_00ffff
var defaultSpaceColor = color.ColorMagenta1_ff00ff
var defaultNULLEOFColor = color.ColorRed1_ff0000
var defaultPrintableASCIIColor = color.ColorDodgerBlue1_0087ff
var defaultUpperBytesColor = color.ColorYellow_ffff00

// Default colors for bytes 0-255
var defaultCharacterColors = [256]color.Color{
	0:   defaultNULLEOFColor, // null
	1:   defaultColor,
	2:   defaultColor,
	3:   defaultColor,
	4:   defaultColor,
	5:   defaultColor,
	6:   defaultColor,
	7:   defaultColor,
	8:   defaultColor,
	9:   defaultSpaceColor, // tab
	10:  defaultLineColor,  // \n
	11:  defaultColor,
	12:  defaultColor,
	13:  defaultLineColor, // \r
	14:  defaultColor,
	15:  defaultColor,
	16:  defaultColor,
	17:  defaultColor,
	18:  defaultColor,
	19:  defaultColor,
	20:  defaultColor,
	21:  defaultColor,
	22:  defaultColor,
	23:  defaultColor,
	24:  defaultColor,
	25:  defaultColor,
	26:  defaultColor,
	27:  defaultColor,
	28:  defaultColor,
	29:  defaultColor,
	30:  defaultColor,
	31:  defaultColor,
	32:  defaultSpaceColor, // space
	33:  defaultPrintableASCIIColor,
	34:  defaultPrintableASCIIColor,
	35:  defaultPrintableASCIIColor,
	36:  defaultPrintableASCIIColor,
	37:  defaultPrintableASCIIColor,
	38:  defaultPrintableASCIIColor,
	39:  defaultPrintableASCIIColor,
	40:  defaultPrintableASCIIColor,
	41:  defaultPrintableASCIIColor,
	42:  defaultPrintableASCIIColor,
	43:  defaultPrintableASCIIColor,
	44:  defaultPrintableASCIIColor,
	45:  defaultPrintableASCIIColor,
	46:  defaultPrintableASCIIColor,
	47:  defaultPrintableASCIIColor,
	48:  defaultPrintableASCIIColor, // 0
	49:  defaultPrintableASCIIColor,
	50:  defaultPrintableASCIIColor,
	51:  defaultPrintableASCIIColor,
	52:  defaultPrintableASCIIColor,
	53:  defaultPrintableASCIIColor,
	54:  defaultPrintableASCIIColor,
	55:  defaultPrintableASCIIColor,
	56:  defaultPrintableASCIIColor,
	57:  defaultPrintableASCIIColor, // 9
	58:  defaultPrintableASCIIColor,
	59:  defaultPrintableASCIIColor,
	60:  defaultPrintableASCIIColor,
	61:  defaultPrintableASCIIColor,
	62:  defaultPrintableASCIIColor,
	63:  defaultPrintableASCIIColor,
	64:  defaultPrintableASCIIColor,
	65:  defaultPrintableASCIIColor, // A
	66:  defaultPrintableASCIIColor,
	67:  defaultPrintableASCIIColor,
	68:  defaultPrintableASCIIColor,
	69:  defaultPrintableASCIIColor,
	70:  defaultPrintableASCIIColor,
	71:  defaultPrintableASCIIColor,
	72:  defaultPrintableASCIIColor,
	73:  defaultPrintableASCIIColor,
	74:  defaultPrintableASCIIColor,
	75:  defaultPrintableASCIIColor,
	76:  defaultPrintableASCIIColor,
	77:  defaultPrintableASCIIColor,
	78:  defaultPrintableASCIIColor,
	79:  defaultPrintableASCIIColor,
	80:  defaultPrintableASCIIColor,
	81:  defaultPrintableASCIIColor,
	82:  defaultPrintableASCIIColor,
	83:  defaultPrintableASCIIColor,
	84:  defaultPrintableASCIIColor,
	85:  defaultPrintableASCIIColor,
	86:  defaultPrintableASCIIColor,
	87:  defaultPrintableASCIIColor,
	88:  defaultPrintableASCIIColor,
	89:  defaultPrintableASCIIColor,
	90:  defaultPrintableASCIIColor, // Z
	91:  defaultPrintableASCIIColor,
	92:  defaultPrintableASCIIColor,
	93:  defaultPrintableASCIIColor,
	94:  defaultPrintableASCIIColor,
	95:  defaultPrintableASCIIColor,
	96:  defaultPrintableASCIIColor,
	97:  defaultPrintableASCIIColor, // a
	98:  defaultPrintableASCIIColor,
	99:  defaultPrintableASCIIColor,
	100: defaultPrintableASCIIColor,
	101: defaultPrintableASCIIColor,
	102: defaultPrintableASCIIColor,
	103: defaultPrintableASCIIColor,
	104: defaultPrintableASCIIColor,
	105: defaultPrintableASCIIColor,
	106: defaultPrintableASCIIColor,
	107: defaultPrintableASCIIColor,
	108: defaultPrintableASCIIColor,
	109: defaultPrintableASCIIColor,
	110: defaultPrintableASCIIColor,
	111: defaultPrintableASCIIColor,
	112: defaultPrintableASCIIColor,
	113: defaultPrintableASCIIColor,
	114: defaultPrintableASCIIColor,
	115: defaultPrintableASCIIColor,
	116: defaultPrintableASCIIColor,
	117: defaultPrintableASCIIColor,
	118: defaultPrintableASCIIColor,
	119: defaultPrintableASCIIColor,
	120: defaultPrintableASCIIColor,
	121: defaultPrintableASCIIColor,
	122: defaultPrintableASCIIColor, // z
	123: defaultPrintableASCIIColor,
	124: defaultPrintableASCIIColor,
	125: defaultPrintableASCIIColor,
	126: defaultPrintableASCIIColor,
	127: defaultUpperBytesColor,
	128: defaultUpperBytesColor,
	129: defaultUpperBytesColor,
	130: defaultUpperBytesColor,
	131: defaultUpperBytesColor,
	132: defaultUpperBytesColor,
	133: defaultUpperBytesColor,
	134: defaultUpperBytesColor,
	135: defaultUpperBytesColor,
	136: defaultUpperBytesColor,
	137: defaultUpperBytesColor,
	138: defaultUpperBytesColor,
	139: defaultUpperBytesColor,
	140: defaultUpperBytesColor,
	141: defaultUpperBytesColor,
	142: defaultUpperBytesColor,
	143: defaultUpperBytesColor,
	144: defaultUpperBytesColor,
	145: defaultUpperBytesColor,
	146: defaultUpperBytesColor,
	147: defaultUpperBytesColor,
	148: defaultUpperBytesColor,
	149: defaultUpperBytesColor,
	150: defaultUpperBytesColor,
	151: defaultUpperBytesColor,
	152: defaultUpperBytesColor,
	153: defaultUpperBytesColor,
	154: defaultUpperBytesColor,
	155: defaultUpperBytesColor,
	156: defaultUpperBytesColor,
	157: defaultUpperBytesColor,
	158: defaultUpperBytesColor,
	159: defaultUpperBytesColor,
	160: defaultUpperBytesColor,
	161: defaultUpperBytesColor,
	162: defaultUpperBytesColor,
	163: defaultUpperBytesColor,
	164: defaultUpperBytesColor,
	165: defaultUpperBytesColor,
	166: defaultUpperBytesColor,
	167: defaultUpperBytesColor,
	168: defaultUpperBytesColor,
	169: defaultUpperBytesColor,
	170: defaultUpperBytesColor,
	171: defaultUpperBytesColor,
	172: defaultUpperBytesColor,
	173: defaultUpperBytesColor,
	174: defaultUpperBytesColor,
	175: defaultUpperBytesColor,
	176: defaultUpperBytesColor,
	177: defaultUpperBytesColor,
	178: defaultUpperBytesColor,
	179: defaultUpperBytesColor,
	180: defaultUpperBytesColor,
	181: defaultUpperBytesColor,
	182: defaultUpperBytesColor,
	183: defaultUpperBytesColor,
	184: defaultUpperBytesColor,
	185: defaultUpperBytesColor,
	186: defaultUpperBytesColor,
	187: defaultUpperBytesColor,
	188: defaultUpperBytesColor,
	189: defaultUpperBytesColor,
	190: defaultUpperBytesColor,
	191: defaultUpperBytesColor,
	192: defaultUpperBytesColor,
	193: defaultUpperBytesColor,
	194: defaultUpperBytesColor,
	195: defaultUpperBytesColor,
	196: defaultUpperBytesColor,
	197: defaultUpperBytesColor,
	198: defaultUpperBytesColor,
	199: defaultUpperBytesColor,
	200: defaultUpperBytesColor,
	201: defaultUpperBytesColor,
	202: defaultUpperBytesColor,
	203: defaultUpperBytesColor,
	204: defaultUpperBytesColor,
	205: defaultUpperBytesColor,
	206: defaultUpperBytesColor,
	207: defaultUpperBytesColor,
	208: defaultUpperBytesColor,
	209: defaultUpperBytesColor,
	210: defaultUpperBytesColor,
	211: defaultUpperBytesColor,
	212: defaultUpperBytesColor,
	213: defaultUpperBytesColor,
	214: defaultUpperBytesColor,
	215: defaultUpperBytesColor,
	216: defaultUpperBytesColor,
	217: defaultUpperBytesColor,
	218: defaultUpperBytesColor,
	219: defaultUpperBytesColor,
	220: defaultUpperBytesColor,
	221: defaultUpperBytesColor,
	222: defaultUpperBytesColor,
	223: defaultUpperBytesColor,
	224: defaultUpperBytesColor,
	225: defaultUpperBytesColor,
	226: defaultUpperBytesColor,
	227: defaultUpperBytesColor,
	228: defaultUpperBytesColor,
	229: defaultUpperBytesColor,
	230: defaultUpperBytesColor,
	231: defaultUpperBytesColor,
	232: defaultUpperBytesColor,
	233: defaultUpperBytesColor,
	234: defaultUpperBytesColor,
	235: defaultUpperBytesColor,
	236: defaultUpperBytesColor,
	237: defaultUpperBytesColor,
	238: defaultUpperBytesColor,
	239: defaultUpperBytesColor,
	240: defaultUpperBytesColor,
	241: defaultUpperBytesColor,
	242: defaultUpperBytesColor,
	243: defaultUpperBytesColor,
	244: defaultUpperBytesColor,
	245: defaultUpperBytesColor,
	246: defaultUpperBytesColor,
	247: defaultUpperBytesColor,
	248: defaultUpperBytesColor,
	249: defaultUpperBytesColor,
	250: defaultUpperBytesColor,
	251: defaultUpperBytesColor,
	252: defaultUpperBytesColor,
	253: defaultUpperBytesColor,
	254: defaultUpperBytesColor,
	255: defaultNULLEOFColor, // 255, 0xFF
}
